--[[

	Translation by Shadow Dragon: Mayara on Sirannon Lotro Server.
	Version: 0.3.2 [4.1.4] 2012-04-24

]]--

_G.L = {};

-- Menu Headings
L['MenuTitle'] = 'Combat Analysis'; -- Utilis?

L['General'] = 'G\195\169n\195\169ral';
L['Buffs'] = 'Buff Info'; -- Utilis?
L['SaveLoad'] = 'Save/Load'; -- Utilis?

-- Value/Date Formatting (Format SI)
L['Thousand'] = 'k';
L['Million'] = 'M';
L['Billion'] = 'G';
L['Trillion'] = 'T';

L['Jan'] = {'Jan', 'Janvier'};
L['Feb'] = {'F\195\169v', 'F\195\169vrier'};
L['Mar'] = {'Mar', 'Mars'};
L['Apr'] = {'Avr', 'Avril'};
L['May'] = {'Mai', 'Mai'};
L['Jun'] = {'Jun', 'Juin'};
L['Jul'] = {'Jul', 'Juillet'};
L['Aug'] = {'Ao\195\187', 'Ao\195\187t'};
L['Sep'] = {'Sep', 'Septembre'};
L['Oct'] = {'Oct', 'Octobre'};
L['Nov'] = {'Nov', 'Novembre'};
L['Dec'] = {'D\195\169c', 'D\195\169cembre'};

-- Options
L['ResetTotalsMessage'] = '\195\138tes-vous s\195\187r de vouloir r\195\169initialiser le cumulatif?';
L['Yes'] = 'Oui';
L['No'] = 'Non';
L['OK'] = 'OK';

L['SaveData'] = 'Enregis. donn\195\169es';
L['LoadData'] = 'Charger donn\195\169es';

-- Select File Dialog
L['Select'] = 'S\195\169lectionner';
L['Save'] = 'Enregistrer';
L['Load'] = 'Charger';
L['Cancel'] = 'Annuler';

L['FileName'] = 'Nom de fichier';

L['SelectAll'] = 'Tout s\195\169lect.';
L['ClearAll'] = 'Tout d\195\169s\195\169lect.';

L['Delete'] = 'Supprimer';

L['AreYouSureYouWantToDeleteMessage'] = '\195\138tes-vous s\195\187r de vouloir supprimer\nle(s) fichier(s) s\195\169lectionn\195\169(s)?';

L['Encounters'] = 'Encounters'; -- Utilis?
L['Items'] = 'Items'; -- Utilis?
L['CombineWith'] = 'Combine With'; -- Utilis?
L['CombineInto'] = 'Combine Into'; -- Utilis?

L['SelectCurrentDataToCombineWith'] = 'Combiner les donn\195\169es charg\195\169es avec les donn\195\169es actuelles';
L['LoadDataAsTotalsEncounter'] = 'Remplacer le cumulatif avec les donn\195\169es charg\195\169es';

L['SelectSaveFile'] = 'Choisir un fichier';
L['SelectFileToLoad'] = 'Charger un fichier';
L['SelectDataToSave'] = 'Enregistrer les donn\195\169es';
L['SelectDataToCombineWith'] = 'Combiner avec';

L['TooLong'] = 'Vous ne pouvez entrer qu\'un maximum de 64 caract\195\168res.'; -- Utilis?
L['IllegalCharacters'] = 'Vous ne pouvez entrer que des lettres, des chiffres, des espaces et des souligns (_)'; -- Utilis?

L['NoDataMessage'] = 'Il n\'y a actuellement aucune donn\195\169es \195\160 enregistrer.';
L['NoFileMessage'] = 'Pas de fichier sp\195\169cifi\195\169.';
L['NoDataSelectedMessage'] = 'Aucune donn\195\169e n\'a \195\169t\195\169 s\195\169lectionn\195\169e.';
L['OverwriteFileMessage'] = 'Le fichier existe d\195\169j\195\160. Voulez-vous combiner les donn\195\169es enregistr\195\169es avec ce fichier ou les remplacer?';
L['CombineOrSeparateMessage'] = 'Vous avez s\195\169lectionn\195\169 plusieurs fichiers. Voulez-vous combiner les donn\195\169es ou les charger s\195\169par\195\169ment?';
L['TooManyCharactersMessage'] = 'Le nom de fichier sp\195\169cifi\195\169 est trop long\n(longueur maximale = 64 caract\195\168res)';
L['InvalidCharactersMessage'] = 'Le nom de fichier sp\195\169cifi\195\169 contient\ndes caract\195\168res non valides.';
L['FileNotFoundMessage'] = 'L\'un des fichiers sp\195\169cifi\195\169 n\'a pu \195\170tre trouv\195\169e.';
L['SaveFailedMessage'] = '\195\137chec de la sauvegarde: '; -- ?
L['LoadFailedMessage'] = '\195\137chec du chargement: ';
L['CombineMessage'] = '\195\138tes-vous s\195\187r de vouloir combiner\nles fichiers s\195\169lectionn\195\169s?'; -- ?
L['LoadBeforeSaveMessage'] = 'L\'un des fichiers s\195\169lectionn\195\169 est actuellement utilis\195\169 et ne peut donc pas \195\170tre encore charg\195\169. Essayez \195\160 nouveau dans environ 10-15 secondes.';

L['Combine'] = 'Combiner';
L['Overwrite'] = 'Remplacer';
L['Combined'] = 'Combiner';
L['Separate'] = 'S\195\169parer';

-- Commands
L['Options'] = 'options';
L['Settings'] = 'param\195\168tres'; -- Utilis?
L['Setup'] = 'configurer'; -- Utilis?
L['CommandUsage'] = 'usage: /ca ' .. L.Options .. ' | ' .. string.lower(L.Save) .. ' | ' .. string.lower(L.Load);

-- Encounter Default Names
L['Totals'] = 'Cumulatif';
L['Encounter'] = 'Rencontre';
L['CurrentEncounter'] = 'Rencontre actuelle';
L['CompletedEncounter'] = 'Rencontre termin\195\169e';

-- Right Click Menu
L['RestoreTab'] = 'Restaurer l\'onglet';
L['CloseTab'] = 'Fermer l\'onglet';
L['AutoSelectPlayer'] = 'S\195\169lection de vos d\195\169tails';
L['AutoHideTabs'] = 'Masquer les onglets';
L['ShowBackground'] = 'Afficher l\'arri\195\168re-plan';
L['ShowMiniTitleBar'] = 'Afficher la barre de titre';
L['ShowTitleAndDuration'] = 'Afficher le titre et la dur\195\169e';
L['ShowEncountersList'] = 'Afficher la liste des rencontres';
L['ShowTargetsList'] = 'Afficher la liste des cibles';
L['ShowExtraButtons'] = 'Afficher les extras';
L['AutoSelectNewEncounters'] = 'S\195\169lection nouvelles rencontres';
L['ResetTotals'] = 'R\195\169initialiser le cumulatif';
L['ConfirmDialogOnReset'] = 'Confirmer: Effacer le cumulatif';

-- Chat Menu (indexed by {command, channel name})
L['Say'] = {'parler', 'Parler'};
L['Fellowship'] = {'comm', 'Communaut\195\169'};
L['Raid'] = {'ra', 'Raid'};
L['Kinship'] = {'conf', 'Confr\195\169rie'};
L['Gap'] = '------------------';

-- Other
L['AllPlayers'] = 'Tous les joueurs';
L['AllSkills'] = 'Comp\195\169tences (tous)';
L['Duration'] = 'Dur\195\169e'; -- Utilis?
L['SendToChat'] = 'Envoi r\195\169sultat';
L['CombatAnalysisSummary'] = 'R\195\169sum\195\169 de Combat Analysis'; -- Utilis?

L['DirectDamage'] = 'D\195\169g\195\162ts au Moral'; -- Non utilis, puisque la syntaxe est la mme pour les autres coups avec dgts.

L['MinutesAbbr'] = 'm';
L['SecondsAbbr'] = 's';

L['Daze'] = 'H\195\169b\195\169tement'; -- ? Utilis dans le players/skills.lua
L['Root'] = 'Enracinement'; -- ? Utilis dans le players/skills.lua
L['Fear'] = 'Peur'; -- ? Utilis dans le players/skills.lua

-- Statistics Headings
L['AllData'] = 'Donn\195\169es (Tous)';
L['NonCrits'] = 'Non critique';
L['Criticals'] = 'Critique';
L['Devastates'] = 'D\195\169vastateur';
L['CritsAndDevs'] = 'Crit & D\195\169vast';
L['Partials'] = '\195\137vit. partiel';

L['Total'] = 'Total';
L['Average'] = 'Moyenne';
L['Maximum'] = 'Maximum';
L['Minimum'] = 'Minimum';

L['CriticalHits'] = 'Coup critique';

L['Avoidance'] = '\195\137vitement';
L['Attacks'] = 'Attaque';
L['Hits'] = 'Coup r\195\169ussi';
L['Absorbs'] = 'Coup absorb\195\169 (***)';
L['Misses'] = 'Coup rat\195\169';
L['Immune'] = 'Coup immunis\195\169';
L['Resists'] = 'Coup r\195\169sist\195\169';
L['PhysicalAvoids'] = '\195\137vitement physique';
L['FullAvoids'] = '\195\137vitement complet';
L['PartialAvoids'] = '\195\137vitement partiel';
L['Avoids'] = '\195\137vitement complet';
L['Blocks'] = 'Blocage';
L['Parrys'] = 'Parade';
L['Evades'] = 'Esquive';
L['PartialBlocks'] = 'Blocage partiel';
L['PartialParrys'] = 'Parade partielle';
L['PartialEvades'] = 'Esquive partielle';

L['Other'] = 'Divers';
L['Interrupts'] = 'Interruption';
L['CorruptionsRemoved'] = 'Corruption retir\195\169e';

L['DmgTypes'] = 'Type de d\195\169g\195\162ts';

L['TempMorale'] = 'Moral temporaire';
L['RegularHeals'] = 'Soin r\195\169gulier';
L['TempHeals'] = 'Soin temporaire';
L['WastedTempHeals'] = '  (gaspill\195\169)';

-- Note the following elements are indexed by: {Short Name, Full Name}
L['Dmg'] = {'Off', 'D\195\169g\195\162ts inflig\195\169s', 'DPS'};
L['Taken'] = {'Def', 'D\195\169g\195\162ts re\195\167us', 'TPS'};
L['Heal'] = {'Soins', 'Soins', 'HPS'};
L['Power'] = {'Puis', 'Absorptions de puissance', 'PPS'};
L['Debuff'] = {'Aff', 'Affaiblissements'};
L['Buff'] = {'Aml', 'Am\195\169liorations'};

L['Death'] = {'Mort', 'Mort'}; -- Utilis?
L['Corruption'] = {'Corruption', 'Corruptions retir\195\169e'}; -- Utilis?
L['Interrupt'] = {'Interruption', 'Interruption'}; -- Utilis?
L['CombatEntered'] = {'D\195\169but combat', 'D\195\169but du combat'}; -- Utilis?
L['CombatExited'] = {'Fin combat', 'Fin du combat'}; -- Utilis?

L['AvoidanceEnum'] = {
	{'Aucun', 'Aucun'},
	{'Rat\195\169', 'Rat\185\169'},
	{'Immunis\195\169', 'Immunis\195\169'},
	{'R\195\169sist\195\169', 'R\195\169sist\195\169'},
	{'Bloqu\195\169', 'Bloqu\195\169'},
	{'Par\195\169', 'Par\195\169'},
	{'Esquiv\195\169', 'Esquiv\195\169'},
	{'Bloqu\195\169-P', 'Bloqu\195\169 partiellement'},
	{'Par\195\169-P', 'Par\195\169 partiellement'},
	{'Esquiv\195\169-P', 'Esquiv\195\169 partiellement'}
};

L['CriticalEnum'] = {
	{'Aucun', 'Aucun'},
	{'Critique', 'Coup critique'},
	{'D\195\169vastateur', 'Coup d\195\169vastateur'}
};

L['DmgTypeEnum'] = {
	{'Commun', 'Commun'},
	{'Feu', 'Feu'},
	{'Foudre', 'Foudre'},
	{'Froid', 'Froid'},
	{'Acide', 'Acide'},
	{'Ombre', 'Ombre'},
	{'Lumi\195\168re', 'Lumi\195\168re'},
	{'Bele', 'Beleriand'},
	{'Ouis', 'Ouistrenesse'},
	{'Nain', 'Nain d\'antan'},
	{'Aucun', 'Aucun'}
};

L['MoralePower'] = {
	{'Moral', 'Moral'},
	{'Puissance', 'Puissance'},
	{'Aucun', 'Aucun'}
};

--[[

The complete parsing function. Since the order of text in the combat log is likely to differ in
different languages, this entire function is included  in the localization class.

The function is given an input line from the combat log, and parses that line to determine its meaning.
The final step in each section is to return the extracted values. These lines need not be updated, but
the correct info must be extracted into the relevant fields.

Note the use of numeric values for avoids, critical hits, dmg types, and morale/power. These numbers
correspond to the orderings in the four lists directly above this comment block.

You will need to know something about lua pattern matching and/or regex's to attempt to translate this
section. See http://www.lua.org/pil/20.2.html for more details.

]]--

-- Temporary function
local use_debug = false;
local function debug(type, line, string)
	if (type == nil or line == nil) then
		return;
	elseif (use_debug) then
		string = (string == nil and '' or ' | ' .. string);
		Turbine.Shell.WriteLine('[' .. type .. '] ' .. line .. string);
	end
end

-- Renvoie un nom sans les articles
local function trim_articles(name)
	if (name == nil) then
		return nil;
	end

	-- Articles possibles: Mayara, LeMayara, Le Mayara, LaMayara, La Mayara, L' Mayara, LMayara, et peut tre d'autres?
	return string.gsub(name, '^[Ll].-(%u)', '%1');
end

-- Renvoie le type de dgts sous format numrique
local function get_dmg_type(dmg_type)
	dmg_type =
		dmg_type == 'Commun' and 1 or
		dmg_type == 'Feu' and 2 or
		dmg_type == 'Foudre' and 3 or
		dmg_type == 'Froid' and 4 or
		dmg_type == 'Acide' and 5 or
		dmg_type == 'Ombre' and 6 or
		dmg_type == 'Lumi\195\168re' and 7 or
		dmg_type == 'Beleriand' and 8 or
		dmg_type == 'Ouistrenesse' and 9 or
		dmg_type == 'de nain d\'antan' and 10 or
		11;

	return dmg_type;
end

L['Parse'] = function(line)
	local match, initiator_name, target_name, skill_name, hit_type, dmg_amount, dmg_type, avoid_type, crit_type, morale_power;

	--
	-- 1) Les dgts (Damage line)
	--
	-- [mrlDmg]: Mayara a inflig un coup avec une attaque au corps  corps sur le Mannequin d'entranement pour 257 points de type Commun  l'entit Moral.
	-- [pwrDmg]: Mayara a inflig un coup avec Vol de Puissance (Aspiration) sur le Lynx de Houssaye pour 22 points de type  l'entit Puissance.
	-- [dirDmg]: Rocher qui tombe a inflig un coup avec Dgts au Moral sur Mayara pour 712 points de type  l'entit Moral.
	-- [absDmg]: L' Mayara a marqu un coup avec une attaque au corps  corps sur le Fauconnier maudit.
	--

	-- Dgts (Damage)
	match = '^(.*) a inflig\195\169 un coup(.*) avec (.*) sur (.*) pour ([%d,]*) points? de type ?(.*) \195\160 l\'entit\195\169 ?(.*)%.$';
	initiator_name, hit_type, skill_name, target_name, dmg_amount, dmg_type, morale_power = string.match(line, match);

	if (initiator_name ~= nil) then
		avoid_type =
			string.match(hit_type, 'partiellement bloqu\195\169') and 8 or
			string.match(hit_type, 'partiellement par\195\169') and 9 or
			string.match(hit_type, 'partiellement esquiv\195\169') and 10 or
			1;
		crit_type =
			string.match(hit_type, 'critique') and 2 or
			string.match(hit_type, 'd\195\169vastateur') and 3 or
			1;

		dmg_amount = string.gsub(dmg_amount, ',', '') + 0;
		dmg_type = get_dmg_type(dmg_type); 
		morale_power = (morale_power == 'Moral' and 1 or (morale_power == 'Puissance' and 2 or 3));

		-- Dgts sur la puissance (Damage to power)
		if (morale_power == 2) then
			return nil;
		end

		return 1, trim_articles(initiator_name), trim_articles(target_name), skill_name, dmg_amount, avoid_type, crit_type, dmg_type;
	end

	-- Dgts absorbs ou comptences sans dgts [Debuffs, CC, ...] (Damage was absorbed)
	initiator_name, skill_name, target_name = string.match(line, '^(.*) a marqu\195\169 un coup.* avec (.*) sur (.*)%.$');

	if (initiator_name ~= nil) then
		avoid_type = 1;
		crit_type = 1;
		dmg_amount = 0;
		dmg_type = get_dmg_type(nil);

		return 1, trim_articles(initiator_name), trim_articles(target_name), skill_name, dmg_amount, avoid_type, crit_type, dmg_type;
	end

	--
	-- 2) Les soins (Heal line)
	--
	-- [slfHeal]: Augmentation du Moral a appliqu un soin  Mayara, redonnant 729 points  l'entit Moral.
	-- [tgtHeal]: Mayara a appliqu un soin avec Augmentation du Moral Player, redonnant 1,167 points  Moral.
	--
	initiator_name, match = string.match(line, '^(.*) a appliqu\195\169 un soin (.*)%.$');

	if (initiator_name ~= nil) then
		crit_type =
      string.match(match, 'critique') and 2 or
			string.match(match, 'd\195\169vastateur') and 3 or
			1;
		match = string.gsub(match, '^critique ', '');
		match = string.gsub(match, '^d\195\169vastateur ', '');

		local self_heal = (string.match(match, '^\195\160 ') and true or false);

		-- Soins personnels (Self heal)
		if (self_heal) then
			skill_name = initiator_name;
			target_name, dmg_amount, morale_power = string.match(match, '^\195\160 (.*), redonnant ([%d,]*) points? \195\160 l\'entit\195\169 ?(.*)$');
			initiator_name = target_name;

		-- Soins sur une cible (Heal applied)
		else
			skill_name, target_name, dmg_amount, morale_power = string.match(match, '^avec (.*) ([^%s]+), redonnant ([%d,]*) points? \195\160 ?(.*)$');
		end

		morale_power = (morale_power == 'Moral' and 1 or (morale_power == 'Puissance' and 2 or 3));
		dmg_amount = (morale_power == 3 and 0 or string.gsub(dmg_amount, ',', '') + 0);

		return (morale_power == 2 and 4 or 3), trim_articles(initiator_name), trim_articles(target_name), skill_name, dmg_amount, crit_type;
	end

	--
	-- 3) Les amliorations (Buff line)
	--
	-- Mayara a appliqu un benefit avec Mlodie de bataille Mayara.
	--
	initiator_name, skill_name, target_name = string.match(line, '^(.*) a appliqu\195\169 un benefit avec (.*) ([^%s]+)%.$');

	if (initiator_name ~= nil) then
		return 17, trim_articles(initiator_name), trim_articles(target_name), skill_name;
	end

	--
	-- 4) Les vitements (Avoid line)
	--
	-- [fullAvd]: L' Lynx de Houssaye a essay d'utiliser une attaque au corps  corps solide sur Mayara mais elle esquiv la tentative.
	-- [missHit]: LaMayara n'a pas russi  utiliser une attaque au corps  corps sur le Lynx de Houssaye.
	--

	-- vitements complets (Full avoids)
	initiator_name, skill_name, target_name, avoid_type = string.match(line, '^(.*) a essay\195\169 d\'utiliser (.*) sur (.*) mais (.*) la tentative%.$');

	if (initiator_name ~= nil) then
		avoid_type =
			string.match(avoid_type, 'bloqu\195\169') and 5 or
			string.match(avoid_type, 'par\195\169') and 6 or
			string.match(avoid_type, 'esquiv\195\169') and 7 or
			string.match(avoid_type, 'r\195\169sist\195\169') and 4 or
			string.match(avoid_type, 'immunis\195\169 contre') and 3 or
			1;

		if (avoid_type == 1) then
			return nil;
		end

		return 1, trim_articles(initiator_name), trim_articles(target_name), skill_name, 0, avoid_type, 1, 10;
	end

	-- Coups rats (Miss)
	initiator_name, skill_name, target_name = string.match(line, '^(.*) n\'a pas r\195\169ussi \195\160 utiliser (.*) sur (.*)%.$');

	if (initiator_name ~= nil) then
		avoid_type = 2;

		return 1, trim_articles(initiator_name), trim_articles(target_name), skill_name, 0, avoid_type, 1, 10;
	end

	--
	-- 5) Les rflexions (Reflect line)
	--
	-- [dmg]  La Mayara a renvoy 16 Commun de dgts au Moral de le Guerrier d'Isengard.
	-- [heal] Le Gorthorog guerrier a renvoy 58 points redonns au Moral de Mayara.
	--

	-- Rflexion de dgts (A damage reflect)
	initiator_name, dmg_amount, dmg_type, target_name = string.match(line, '^(.*) a renvoy\195\169 ([%d,]*) ?(.*) de d\195\169g\195\162ts au Moral de (.*)%.$');

	if (initiator_name ~= nil) then
		skill_name = 'R\195\169flexion';
		dmg_amount = string.gsub(dmg_amount, ',', '') + 0;
		dmg_type = get_dmg_type(dmg_type);

		return 1, trim_articles(initiator_name), trim_articles(target_name), skill_name, dmg_amount, 1, 1, dmg_type;
	end

	-- Rflexion de soins (A heal reflect)
	initiator_name, dmg_amount, target_name = string.match(line, '^(.*) a renvoy\195\169 ([%d,]*) points? redonn\195\169s? au Moral de (.*)%.$');

	if (initiator_name ~= nil) then
		skill_name = 'R\195\169flexion';
		dmg_amount = string.gsub(dmg_amount, ',', '') + 0;

		return 3, trim_articles(initiatorName), trim_articles(target_name), skill_name, dmg_amount, 1;
	end

	--
	-- 6) Le moral temporaire (Temporary Morale bubble line)
	--
	-- Vous avez perdu 180 points de Moral temporaire !
	--
	dmg_amount = string.match(line, '^Vous avez perdu ([%d,]*) points de Moral temporaire !$');

	if (dmg_amount ~= nil) then
		dmg_amount = string.gsub(dmg_amount, ',', '') + 0;

		return 14, nil, player.name, nil, dmg_amount;
	end

	--
	-- 7) Les incapacits rompues (Combat State Break notice)
	--
	-- [Todo] Vrifier d'avoir tous les logs.
	--

	-- 7a) Enracinement rompu (Root broken)
	-- [you-oth] Vous avez dlivr Anctre errebois de l'immobilisation!
	-- [oth-oth] Mayara a dlivr Tratre du Gondor de l'immobilisation!
	-- [oth-you] Sorcier de la caste bleue vous a dlivre de l'immobilisation! -- Note: dlivr|dlivre
	initiator_name, target_name = string.match(line, '^(.*) d\195\169livr\195\169e? ?(.*) de l\'immobilisation\194\160!$');

	if (initiator_name ~= nil) then
		initiator_name =
			string.match(initiator_name, '^Vous avez') and player.name or
			string.match(initiator_name, ' vous a$') and string.gsub(initiator_name, ' vous a$', '') or
			string.gsub(initiator_name, ' a$', '');
		target_name = (target_name == '' and player.name or target_name);

		-- BEGIN DEBUG
		debug('root_broken', line, 'ini_name: ' .. initiator_name .. ' tgt_name: ' .. target_name);
		-- END DEBUG

		return 16, nil, trim_articles(target_name), nil;
	end

	-- 7b) Hbtement rompu (Daze broken)
	-- [you-oth] Vous avez dlivr Anctre errebois de l'hbtement!
	-- [oth-oth] Mayara a dlivr Tratre du Gondor de l'hbtement!
	-- [oth-you] Berger de l'abject vous a dlivr de l'hbtement! ???  -- Note: dlivr|dlivre
	initiator_name, target_name = string.match(line, '^(.*) d\195\169livr\195\169e? ?(.*) de l\'h\195\169b\195\169tement\194\160!$');

	if (initiator_name ~= nil) then
		initiator_name =
			string.match(initiator_name, '^Vous avez') and player.name or
			string.match(initiator_name, ' vous a$') and string.gsub(initiator_name, ' vous a$', '') or
			string.gsub(initiator_name, ' a$', '');
		target_name = (target_name == '' and player.name or target_name);

		-- BEGIN DEBUG
		debug('daze_broken', line, 'ini_name: ' .. initiator_name .. ' tgt_name: ' .. target_name);
		-- END DEBUG

		return 16, nil, trim_articles(target_name), nil;
	end

	-- 7c) Peur rompue (Fear broken)
	-- [you-oth] Votre attaque a dissip la peur qui treignait Soldat impnitent!
	-- [oth-oth] Mayara a dissip la peur qui treignait Archer de la Moria en l'attaquant!
	-- [oth-you] Berger de l'abject a dissip la peur qui vous treignait! ???
	initiator_name, target_name = string.match(line, '^(.*) a dissip\195\169 la peur qui.* \195\169treignait ?(.*)\194\160!$');

	if (initiator_name ~= nil) then
		initiator_name = (string.match(initiator_name, '^Votre attaque') and player.name or initiator_name);
		target_name = (target_name == '' and player.name or string.gsub(target_name, ' en l\'attaquant$', ''));

		-- BEGIN DEBUG
		debug('fear_broken', line, 'ini_name: ' .. initiator_name .. ' tgt_name: ' .. target_name);
		-- END DEBUG

		return 16, nil, trim_articles(target_name), nil;
	end

	--
	-- 8) Les interruptions (Interrupt line)
	--
	-- Le Barghest  poigne de fer a t interrompu par Mayara!
	--
	target_name, initiator_name = string.match(line, '^(.*) a \195\169t\195\169 interrompu par (.*)!$');

	if (target_name ~= nil) then
		return 7, trim_articles(initiator_name), trim_articles(target_name);
	end

	--
	-- 9) Les dissipations (Dispel line)
	--
	-- Vous avez dissip l'effet Rage sanguinaire affectant Guerrier d'Isengard.
	-- Il n'y a rien  dissiper.
	--
	local corruption, target_name = string.match(line, 'Vous avez dissip\195\169 l\'effet (.*) affectant (.*)%.$');

	if (corruption ~= nil) then
		initiator_name = player.name;

		return 8, initiator_name, trim_articles(target_name);
	end

	--
	-- 10) Defeat lines
	--

	-- 10a) Defeat line 1 (mob or player was killed)
	initiator_name = string.match(line, '^.* a vaincu (.*)%.$');

	if (initiator_name ~= nil) then
		return 9, trim_articles(initiator_name);
	end

	-- 10b) Defeat line 2 (mob died)
	initiator_name = string.match(line, '^(.*) meurt%.$');

	if (initiator_name ~= nil) then
		return 9, trim_articles(initiator_name);
	end

	-- 10c) Defeat line 3 (a player was killed or died)
	initiator_name = string.match(line, '^(.*) a p\195\169ri%.$');

	if (initiator_name ~= nil) then
		return 9, trim_articles(initiator_name);
	end

	-- 10d) Defeat line 4 (you were killed)
	match = string.match(line, '^.* a r\195\169ussi \195\160 vous mettre hors de combat%.$');

	if (match ~= nil) then
		return 9, player.name;
	end

	-- 10e) Defeat line 5 (you died)
	match = string.match(line, '^Un incident vous a r\195\168duit \195\160 l\'impuissance%.$');

	if (match ~= nil) then
		return 9, player.name;
	end

	-- 10f) Defeat line 6 (you killed a mob) -- Voir: Defeat line 1

	--
	-- 11) Revive lines
	--

	-- 11a) Revive line 1 (player revived)
	initiator_name = string.match(line, '^(.*) revient \195\160 la vie%.$');
	
	if (initiator_name ~= nil) then
	  return 10, trim_articles(initiator_name);
	end

	-- 11b) Revive line 2 (player succumbed)
	initiator_name = string.match(line, '^(.*) a succomb\195\169 \195\160 ses blessures%.$');
	
	if (initiator_name ~= nil) then
	  return 10, trim_articles(initiator_name);
	end

	-- 11c) Revive line 3 (you were revived)
	match = string.match(line, '^Vous revenez \195\160 la vie%.$');

	if (match ~= nil) then
	  return 10, player.name;
	end

	-- 11d) Revive line 4 (you succumbed)
	match = string.match(line, '^You succumb to your wounds%.$'); -- [besoin du log]

	if (match ~= nil) then
	  return 10, player.name;
	end

	-- BEGIN DEBUG
	debug('ELSE:', line);
	-- END DEBUG
end

--[[
	
	Skill Names (for Temporary Morale & Buff/Debuff tracking)
	
	> Temporary Morale Skill Names need specify both how the skill name appears in the combat log, as
	    well as how it appears on the effect tooltip.
	
	> Buff Names must match exactly how the name of a skill appears in the effect tooltip.
	> Benefit/Debuff/Crowd-Control Names must match exactly how the name of a skill appears in the combat log.
	
--]]

-- 0) Temporary Morale Skills {combat log name, effect name}

-- Captain
L['ShieldOfTheDunedainTM'] = {'Shield of the D\195\186nedain','Shield of the D\195\186nedain'}; -- todo
-- Champion
L['TrueHeroicsTM'] = {'True Heroics','True Heroics'}; -- todo
L['SuddenDefenceTM'] = {'Sudden Defence','Sudden Defence'}; -- todo
-- Minstrel
L['StoryOfTheHammerhandTM'] = {'Story of the Hammerhand','Story of the Hammerhand'}; -- todo
L['SongOfTheHammerhandTM'] = {'Chant de Poing de Marteau', 'Chant du Poing de Marteau'};
L['GiftOfTheHammerhandTM'] = {'Gift of the Hammerhand','Gift of the Hammerhand'}; -- todo
-- Rune-Keeper
L['WordOfExaltationTM'] = {'Word of Exaltation','Word of Exaltation'}; -- todo
L['EssayOfExaltationTM'] = {'Essay of Exaltation','Word of Exaltation'}; -- todo

--
-- 1) Comptences du Cambrioleur (Burglar Skills)
--

-- Buffs (effect name)
L['TouchAndGo'] = 'Sur un fil';
L['KnivesOut'] = 'A couteaux tir\195\169s';
L['Mischievous'] = 'Malice';
L['QuietKnife'] = 'Poignard silencieux';
L['Gambler'] = 'Parieur';
L['Feint'] = 'Feinte';
L['ImprovedFeint'] = 'Improved Feint'; -- todo

-- Debuffs (log name)
L['RevealWeakness'] = 'R\195\169v\195\169lation de faiblesse';
L['Addle'] = 'Embrouillement';
L['TrickDisable'] = 'Tour\194\160: incapacit\195\169';
L['TrickCounterDefence'] = 'Tour\194\160: contre-d\195\169fense';
L['TrickImprovedCounterDefence'] = 'Tour\194\160: contre-d\195\169fense improvis\195\169'; -- ?
L['TrickDustInTheEyes'] = 'Tour\194\160:\npoussi\195\168re dans les yeux';
L['Slowed'] = 'Ralenti';
L['TrickEnrage'] = 'Tour\194\160: emportement';
L['ASmallSnag'] = 'Petit accrochage';
L['QuiteASnag'] = 'Quite a Snag'; -- todo

-- Removals (log name)
L['MischievousDelight'] = 'Plaisir malicieux'; -- semble pas tre dtecter comme removal des tours.
L['MischievousGlee'] = 'Jubilation malicieuse'; -- ?

-- Crowd Control (log name)
L['Riddle'] = 'Enigme';
L['ImprovedRiddle'] = 'Enigme improvis\195\169e'; -- ?
L['Confound'] = 'D\195\169stabilisation';
L['StartlingTwist'] = 'Man\197\147uvre saisissante'; -- ?
L['ImprovedStartlingTwist'] = 'Man\197\147uvre saisissante am\195\169lior\195\169e';
L['AdvancedStartlingTwist'] = 'Man\197\147uvre saisissante avanc\195\169e'; -- ?
L['StunDustTier1'] = 'Stun Dust Tier 1'; -- todo
L['StunDustTier2'] = 'Stun Dust Tier 2'; -- todo
L['StunDustTier3'] = 'Stun Dust Tier 3'; -- todo
L['ExploitOpening'] = 'Exploitation d\'ouverture';
L['Trip'] = 'Croc-en-jambe';
L['MarblesTier1'] = 'Marbles Tier 1'; -- todo
L['MarblesTier2'] = 'Marbles Tier 2'; -- todo
L['MarblesTier3'] = 'Marbles Tier 3'; -- todo

-- 2) Captain Skills

-- Buffs (effect name)
L['MusterCourage'] = 'Muster Courage';
L['InHarmsWay'] = 'In Harm\'s Way';
L['WarCry'] = 'War-cry';
L['BladeOfElendil'] = 'Blade of Elendil';
L['Motivated'] = 'Motivated';
L['OnGuard'] = 'On Guard';
L['RelentlessAttack'] = 'Relentless Attack';
L['Focus'] = 'Focus';
L['ShieldBrother'] = 'Shield-brother';
L['WatchfulShieldBrother'] = 'Watchful Shield-brother';
L['SongBrother'] = 'Song-brother';
L['BladeBrother'] = 'Blade-brother';
L['ToArmsShieldBrother'] = 'To Arms (Shield-brother)';
L['ToArmsFellowshipShieldBrother'] = 'To Arms (Fellowship Shield-brother)';
L['ToArmsSongBrother'] = 'To Arms (Song-brother)';
L['ToArmsFellowshipSongBrother'] = 'To Arms (Fellowship Song-brother)';
L['ToArmsBladeBrother'] = 'To Arms (Blade-brother)';
L['ToArmsFellowshipBladeBrother'] = 'To Arms (Fellowship Blade-brother)';
L['StrengthOfWillShieldBrother'] = 'Strength of Will (Shield-brother)';
L['StrengthOfWillFellowshipShieldBrother'] = 'Strength of Will (Fellowship Shield-brother)';
L['StrengthOfWillSongBrother'] = 'Strength of Will (Song-brother)';
L['StrengthOfWillFellowshipSongBrother'] = 'Strength of Will (Fellowship Song-brother)';
L['StrengthOfWillBladeBrother'] = 'Strength of Will (Blade-brother)';
L['StrengthOfWillFellowshipBladeBrother'] = 'Strength of Will (Fellowship Blade-brother)';
L['RallyingCry'] = 'Rallying Cry';
L['InDefenceOfMiddleEarth'] = 'In Defence of Middle-earth';
L['DefensiveStrike'] = 'Defensive Strike';
L['ImprovedDefensiveStrike'] = 'Improved Defensive Strike';
L['LastStand'] = 'Last Stand';
-- Debuffs (log name)
L['NobleMark'] = 'Noble Mark';
L['TellingMark'] = 'Telling Mark';
L['RevealingMark'] = 'Revealing Mark';

-- 3) Champion Skills

-- Buffs (effect name)
L['Fervour'] = 'Fervour';
L['Glory'] = 'Glory';
L['Ardour'] = 'Ardour';
L['ControlledBurn'] = 'Controlled Burn';
L['Flurry'] = 'Flurry';
L['SuddenDefence'] = 'Sudden Defence';
L['SeekingBlades'] = 'Seeking Blades';
L['Adamant'] = 'Adamant';
L['Invincible'] = 'Invincible';
-- Benefits (log name)
L['EbbingIre'] = 'Ebbing Ire';
L['RisingIre'] = 'Rising Ire';

-- 4) Guardian Skills

-- Buffs (effect name)
L['Protection'] = 'Protection';
L['ProtectionByTheSword'] = 'Protection by the Sword';
L['ShieldWall'] = 'Shield Wall';
L['GuardiansBlockStance'] = 'Guardian\'s Block Stance';
L['GuardiansParryStance'] = 'Guardian\'s Parry Stance';
L['Overpower'] = 'Overpower';
L['GuardiansThreatStance'] = 'Guardian\'s Threat Stance';
L['GuardiansPledge'] = 'Guardian\'s Pledge';
L['GuardiansWard'] = 'Guardian\'s Ward';
L['ImprovedGuardiansWard'] = 'Improved Guardian\'s Ward';
L['GuardiansWardTactics'] = 'Guardian\'s Ward Tactics';
L['ImprovedGuardiansWardTactics'] = 'Improved Guardian\'s Ward Tactics';
L['WarriorsBlock'] = 'Warrior\'s Block';
L['WarriorsParry'] = 'Warrior\'s Parry';
L['WarriorsPower'] = 'Warrior\'s Power';
L['WarriorsThreat'] = 'Warrior\'s Threat';
-- Debuffs (log name)
L['Challenge'] = 'Challenge';
L['ImprovedChallenge'] = 'Improved Challenge';
L['ImprovedOverwhelm'] = 'Improved Overwhelm';

-- 5) Hunter Skills

-- Buffs (effect name)
L['StanceStrength'] = 'Stance: Strength';
L['StancePrecision'] = 'Stance: Precision';
L['StanceEndurance'] = 'Stance: Endurance';
L['BurnHot'] = 'Burn Hot';
L['CoolBurn'] = 'Cool Burn';
L['Fleetness'] = 'Fleetness';
L['ImprovedFleetness'] = 'Improved Fleetness';
L['SwiftStroke'] = 'Swift Stroke';
L['NeedfulHaste'] = 'Needful Haste';
L['HuntersArt'] = 'Hunter\'s Art';
-- Crowd Control (log name)
L['DazingBlow'] = 'Dazing Blow';
L['ImprovedDazingBlow'] = 'Improved Dazing Blow';
L['DistractingShot'] = 'Distracting Shot';
L['RainOfThorns'] = 'Rain of Thorns';
L['CryOfThePredator'] = 'Cry of the Predator';
L['BardsArrow'] = 'Bard\'s Arrow';
L['TrapDamage'] = 'Trap Damage';

--
-- 6) Comptences du Matre du savoir (Lore-Master Skills)
--

-- Buffs (effect name)
L['AirLore'] = 'Air \195\169lectrique'; -- Inutile vu que ce sort ne peut tre que sur une autre pnj, donc non affich.
L['ContinualAirLore'] = 'Continual Air-lore'; -- todo
L['SignOfPowerRighteousness'] = 'Signe du pouvoir\194\160:\nInt\195\169grit\195\169';
L['SignOfPowerVigilance'] = 'Signe du pouvoir\194\160:\nVigilance';
L['SignOfTheWildRage'] = 'Signe sauvage\194\160:\nRage'; -- Non dtect Pet Benefit
L['ImprovedSignOfTheWildRage'] = 'Improved Sign of the Wild: Rage'; -- todo
L['SignOfTheWildProtection'] = 'Signe sauvage\194\160:\nProtection'; -- Non dtect Pet Benefit

-- Debuffs (log name)
L['KnowledgeOfTheLoreMaster'] = 'Connaissance du ma\195\174tre du savoir'; -- non dtect
L['GustOfWind'] = 'Bourrasque';
L['FireLore'] = 'Connaissance du feu';
L['WindLore'] = 'Connaissance du vent';
L['FrostLore'] = 'Connaissance du froid';
L['AncientCraft'] = 'Artisanat ancien';
L['SignOfPowerCommand'] = 'Signe du pouvoir\194\160:\nInjonction';
L['ImprovedSignOfPowerCommand'] = 'Improved Sign of Power: Command'; -- todo
L['SignOfPowerSeeAllEnds'] = 'Sign of Power: See All Ends'; -- todo

-- Crowd Control (log name)
L['BlindingFlash'] = 'Lumi\195\168re aveuglante'; -- ?
L['ImprovedBlindingFlash'] = 'Lumi\195\168re aveuglante am\195\169lior\195\169e';
L['BaneFlare'] = 'Eclat fatal';
L['HerbLore'] = 'Connaissance des plantes';
L['CrackedEarth'] = 'Terre craquel\195\169e';

--
-- 7) Comptences du Mnestrel (Minstrel Skills)
--

-- Buffs (effect name)
L['AnthemOfWar'] = 'Hymne de guerre';
L['AnthemOfTheFreePeoples'] = 'Hymne des Peuples Libres';
L['AnthemOfProwess'] = 'Hymne aux prouesses';
L['AnthemOfComposure'] = 'Hymne de contenance';
L['TheMelodyOfBattle'] = 'M\195\169lodie de bataille';
L['InspireFellows'] = 'Inspiration de renforts';
L['SoliloquyOfSpirit'] = 'Esprit de soliloque';
L['ImprovedChordOfSalvation'] = 'Accord enjou\195\169';
L['TaleOfHeroism'] = 'Epop\195\169e h\195\169ro\195\175que';
L['TaleOfBattle'] = 'Epop\195\169e de combat';
L['TaleOfWarding'] = 'Epop\195\169e de protection'; -- ???
L['TaleOfWardingAndHope'] = 'Epop\195\169e de protection et d\'espoir';
L['TaleOfFrostAndFlame'] = 'Epop\195\169e du froid et du feu';
L['TaleOfFrostAndFlamesBattle'] = 'Epop\195\169e de combat am\195\169lior\195\169e'; -- *
L['TaleOfWardingAndHeroism'] = 'Epop\195\169e de protection am\195\169lior\195\169e'; -- *
L['SymphonyOfTheHopefulHeart'] = 'Symphonie d\'espoir du c\197\147ur';
L['Harmony'] = 'Harmonie';
L['WarSpeech'] = 'Discours de guerre';
L['AnthemOfCompassion'] = 'Hymne de sympathie';
L['AnthemOfTheThirdAge'] = 'Hymne du Troisi\195\168me Age';
L['AnthemOfTheThirdAgeWarSpeech'] = 'Hymne du Troisi\195\168me Age (Discours de guerre)';
L['AnthemOfTheThirdAgeHarmony'] = 'Hymne du Troisi\195\168me \195\162ge (Harmonie)';
L['MinorBallad'] = 'Bonus de d\195\169g\195\162ts des ballades';
L['MajorBallad'] = 'Bonus de gu\195\169rison de ballade (Niveau 1)';
L['PerfectBallad'] = 'Bonus de puissance des ballades';
L['StillAsDeath'] = 'Immobilit\195\169 de cadavre';

-- Crowd Control (log name)
L['SongOfTheDead'] = 'Chant des morts';
L['InvocationOfElbereth'] = 'Invocation d\'Elbereth';

-- 8) Rune-Keeper Skills

-- Buffs (effect name)
L['DoNotFallToStorm'] = 'Do Not Fall to Storm';
L['DoNotFallToFlame'] = 'Do Not Fall to Flame';
L['DoNotFallToWinter'] = 'Do Not Fall to Winter';
L['DoNotFallThisDay'] = 'Do Not Fall This Day';
L['ShallNotFallThisDay'] = 'Shall Not Fall This Day';
L['PreludeToHope'] = 'Prelude to Hope';
L['RuneOfRestoration'] = 'Rune of Restoration';
L['WritOfHealthTier1'] = 'Writ of Health - Tier 1';
L['WritOfHealthTier2'] = 'Writ of Health - Tier 2';
L['WritOfHealthTier3'] = 'Writ of Health - Tier 3';
L['OurFatesEntwined'] = 'Our Fates Entwined';
L['AllFatesEntwined'] = 'All Fates Entwined';
L['GloriousForeshadowing'] = 'Glorious Foreshadowing';
L['WondrousForeshadowing'] = 'Wondrous Foreshadowing';

--
-- 9) Comptences de la Sentinelle (Warden Skills)
--

-- Buffs (effect name)
L['Conviction'] = 'Conviction'; -- todo: niv.64
L['DeterminationStance'] = 'D\195\169termination';
L['Conservation'] = 'Assaut';
L['Recklessness'] = 'Imprudence';
L['WayOfTheWarden'] = 'Voie de la sentinelle';
L['ShieldBashBlock'] = 'Violent coup de bouclier\194\160- Blocage';
L['WallOfSteelParry'] = 'Mur d\'acier\194\160: parade';
L['AdroitManoeuvre'] = 'Adroit Manoeuvre'; -- todo: niv.58
L['WardensTriumph'] = 'Warden\'s Triumph'; -- todo: niv.70
L['DefensiveStrikeBlock'] = 'Attaque retenue\194\160: blocage';
L['Persevere'] = 'Persevere'; -- ??? Tier 1 +block +2% partial block
L['ShieldMastery'] = 'Ma\195\174trise du bouclier';
L['ShieldDefence'] = 'D\195\169fense de bouclier';
L['ShieldTactics'] = 'Shield-tactics'; -- todo: niv.68
L['DanceOfBattleEvade'] = 'Danse de guerre\194\160: esquive';
L['TacticallySound'] = 'Tactically Sound'; -- ???
L['T1HealOverTime'] = 'Gu\195\169rison au fil du temps de niveau 1';
L['T2HealOverTime'] = 'Gu\195\169rison au fil du temps de niveau 2';
L['T3HealOverTime'] = 'Gu\195\169rison au fil du temps de niveau 3';
L['T4HealOverTime'] = 'Gu\195\169rison au fil du temps de niveau 4'; -- ?

-- 10) Racial Skills
L['DutyBound'] = 'Duty Bound';
L["DwarfEndurance"] = "Dwarf Endurance"; -- TODO: Check

-- Other
L['StunImmunity'] = 'Immunit\195\169 contre les \195\169tats temporaires'; -- ?